/* ---------------------------------------------------------------- *
 * Systick time handle for the STM32 Cortex-M3 CPU                  *
 * Copyright (c) 2010.11.20  BoFF                                   *
 * Lucjan Bryndza <lucjan.bryndza@ep.com.pl>                        *
 * -----------------------------------------------------------------*/

#include <stm32f10x_lib.h>
#include "time.h"
#include "config.h"
#include "system.h"
/* ---------------------------------------------------------------------------- */
#define TIME_SYSTICK_PRIORITY 0x1
#define TIME_SYSTICK_SUBPRIO  0x7

/* ---------------------------------------------------------------------------- */
#define CTRL_TICKINT_Set 2
#define SysTick_Counter_Enable 1
#define MHZ 1000000UL

static tick_t jiffies;

/* ---------------------------------------------------------------------------- */
//Initialize the system timer
void time_init(void)
{
    //Set Lowest timer Interrupt priority
    nvic_set_priority(SysTick_IRQn,TIME_SYSTICK_PRIORITY,TIME_SYSTICK_SUBPRIO);
    SysTick->LOAD = HZ * (CONFIG_HCLK_HZ/(8*MHZ));
    SysTick->CTRL |= CTRL_TICKINT_Set;
    //System counter enable
    SysTick->CTRL |= SysTick_Counter_Enable;
}
/* ---------------------------------------------------------------------------- */
//! Systick interrupt
void systick_isr_vector(void) __attribute__ ((interrupt));
void systick_isr_vector(void)
{
    jiffies++;
}

/* ---------------------------------------------------------------------------- */
//Read the jiffies
tick_t read_tick(void)
{
    return jiffies;
}

/* ---------------------------------------------------------------------------- */

